﻿//Рассчитываем площадь всех размещенных (видимых) графических элементов в квадратных сантиметрах
//Inline-графика, расположенная в неразмещенном тексте, а также на скрытых слоях не учитывается

var myCalcSquare = CalcSquare();

alert("Количество всех иллюстраций (формул)\nв видимых слоях  = " + myCalcSquare[0] + "\n\nОбщая площадь всех видимых иллюстраций = " + myCalcSquare[1] + " кв. см");

//**************************************************************************************Блок рабочей формулы***************************************************************************************//

function CalcSquare() {

	var myDocument = app.activeDocument;
	var mySquare = 0; //Начальная площадь иллюстраций = 0
	var myReturn = [0,0];
	//Устанавливаем единицы измерения - сантиметры
	with (myDocument.viewPreferences)
		{
		myOldXUnits = horizontalMeasurementUnits;
		myOldYUnits = verticalMeasurementUnits;
		horizontalMeasurementUnits = MeasurementUnits.CENTIMETERS;
		verticalMeasurementUnits = MeasurementUnits.CENTIMETERS;
		}
	
	var Len = 0; //Начальное количество иллюстраций = 0
	var myLayers = myDocument.layers;
	for (var j = 0; j < myLayers.length; j++) {
		
		if (myLayers[j].visible) {

			var myRectangles = myLayers[j].rectangles;
			Len += myRectangles.length;
			for (var m = 0; m < myRectangles.length; m++) {
				var myGraphic = myRectangles[m].graphics.item(0);
				if (myGraphic != null) { //Если в Rectangle содержится графика, то работаем далее
					var myGraphicLink = myGraphic.itemLink;
					//Далее идущие две строки можно отключить, ибо они не связаны с основной фукнциональностью скрипта,
					//а проверяют правильность связи (УБЕРИТЕ ЗНАК КОММЕНТАРИЕВ - (//) ДЛЯ ВКЛЮЧЕНИЯ ЭТИХ ФУНКЦИЙ)
					//if (myGraphicLink.status != LinkStatus.NORMAL) {myGraphicLink.update()}
					//и подгоняют текстовый фрейм по графическому объекту - аналог команды Ctrl + C
					//myRectangles[m].geometricBounds = myGraphic.geometricBounds;
					mySquareGraph = (myRectangles[m].geometricBounds[2] - myRectangles[m].geometricBounds[0])*(myRectangles[m].geometricBounds[3] - myRectangles[m].geometricBounds[1]);
					mySquare += mySquareGraph;
					} //if (myGraphic != null)
				} //for (var m = 0; m < myRectangles.length; m++)
			
			var myTextFrames = myLayers[j].textFrames

			for (var k = 0; k < myTextFrames.length; k++) {
			var myRectangles = myTextFrames[k].rectangles;
			Len += myRectangles.length;
			for (var i = 0; i < myRectangles.length; i++) {
				var myGraphic = myRectangles[i].graphics.item(0);
				if (myGraphic != null) { //Если в Rectangle содержится графика, то работаем далее
					var myGraphicLink = myGraphic.itemLink;
					//Далее идущие две строки можно отключить, ибо они не связаны с основной фукнциональностью скрипта,
					//а проверяют правильность связи (УБЕРИТЕ ЗНАК КОММЕНТАРИЕВ - (//) ДЛЯ ВКЛЮЧЕНИЯ ЭТИХ ФУНКЦИЙ)
					//if (myGraphicLink.status != LinkStatus.NORMAL) {myGraphicLink.update()}
					//и подгоняют текстовый фрейм по графическому объекту - аналог команды Ctrl + C
					//myRectangles[i].geometricBounds = myGraphic.geometricBounds;
					mySquareGraph = (myRectangles[i].geometricBounds[2] - myRectangles[i].geometricBounds[0])*(myRectangles[i].geometricBounds[3] - myRectangles[i].geometricBounds[1]);
					mySquare += mySquareGraph;
					} //if (myGraphic != null)
				}//for (var i = 0; i < myRectangles.length; i++)
			} //if (myLayers[j].visible)
			} //for (var k = 0; k < myTextFrames.length; k++)
		} //for (var j = 0; j < myLayers.length; j++)
	
	//Возвращаем исходные единицы измерения
	with (myDocument.viewPreferences) {
		horizontalMeasurementUnits = myOldXUnits;
		verticalMeasurementUnits = myOldYUnits;
	}
	myReturn = [Len,mySquare];
return myReturn;
}